<template>
  <div :style="{ width: width + 'px', height: height + 'px' }">
    <svg width="100%" height="100%" />
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch, Prop } from "vue-property-decorator";
import * as d3 from "d3";
import { debounce } from "debounce";

@Component
export default class Graph extends Vue {
  @Prop(Array) readonly nodes: any[] | undefined;
  @Prop(Array) readonly links: any[] | undefined;
  public width = window.innerWidth;
  public height = window.innerHeight;
  public selections: any = {};
  public simulation: any = null;
  public forceProperties = {
    center: {
      x: 0.5,
      y: 0.5
    },
    charge: {
      enabled: true,
      strength: -300,
      distanceMin: 1,
      distanceMax: 2000
    },
    collide: {
      enabled: true,
      strength: 0.7,
      iterations: 1,
      radius: 35
    },
    forceX: {
      enabled: false,
      strength: 0.1,
      x: 0.5
    },
    forceY: {
      enabled: false,
      strength: 0.35,
      y: 0.5
    },
    link: {
      enabled: true,
      distance: 100,
      iterations: 1
    }
  };

  get grafo() {
    return { nodes: this.nodes, links: this.links };
  }

  tick() {
    const transform = (d: any) => {
      return "translate(" + d.x + "," + d.y + ")";
    };

    const link = (d: any) => {
      return (
        "M" +
        d.source.x +
        "," +
        d.source.y +
        " L" +
        d.target.x +
        "," +
        d.target.y
      );
    };
    const graph = this.selections.graph;
    graph.selectAll("path").attr("d", link);
    graph.selectAll("circle").attr("transform", transform);
    graph.selectAll("text").attr("transform", transform);
  }

  updateData() {
    this.simulation.nodes(this.nodes);
    this.simulation.force("link").links(this.links);

    const simulation = this.simulation;
    const graph = this.selections.graph;

    // Links should only exit if not needed anymore
    graph
      .selectAll("path")
      .data(this.links)
      .exit()
      .remove();

    graph
      .selectAll("path")
      .data(this.links)
      .enter()
      .append("path")
      .attr("class", (d: any) => "link " + d.type);

    // Nodes should always be redrawn to avoid lines above them
    graph.selectAll("circle").remove();
    graph
      .selectAll("circle")
      .data(this.nodes)
      .enter()
      .append("circle")
      .attr("r", 30)
      .attr("class", (d: any) => d.class);

    graph.selectAll("text").remove();
    graph
      .selectAll("text")
      .data(this.nodes)
      .enter()
      .append("text")
      .attr("x", 0)
      .attr("y", ".31em")
      .attr("text-anchor", "middle")
      .text((d: any) => d.name);

    // Add 'marker-end' attribute to each path
    const svg = d3.select(this.$el.querySelector("svg"));
    svg
      .selectAll("g")
      .selectAll("path")
      .attr("marker-end", (d: any) => {
        // Caption items doesn't have source and target
        if (d.source && d.target && d.source.index === d.target.index)
          return "url(#end-self)";
        else return "url(#end)";
      });

    // Update caption every time data changes
    simulation.alpha(1).restart();
  }

  updateForces() {
    const { simulation, forceProperties, width, height } = this;
    simulation
      .force("center")
      .x(width * forceProperties.center.x)
      .y(height * forceProperties.center.y);
    simulation
      .force("charge")
      .strength(
        forceProperties.charge.enabled ? forceProperties.charge.strength : 0
      )
      .distanceMin(forceProperties.charge.distanceMin)
      .distanceMax(forceProperties.charge.distanceMax);
    simulation
      .force("collide")
      .strength(
        forceProperties.collide.enabled ? forceProperties.collide.strength : 0
      )
      .radius(forceProperties.collide.radius)
      .iterations(forceProperties.collide.iterations);
    simulation
      .force("forceX")
      .strength(
        forceProperties.forceX.enabled ? forceProperties.forceX.strength : 0
      )
      .x(width * forceProperties.forceX.x);
    simulation
      .force("forceY")
      .strength(
        forceProperties.forceY.enabled ? forceProperties.forceY.strength : 0
      )
      .y(height * forceProperties.forceY.y);
    simulation
      .force("link")
      .distance(forceProperties.link.distance)
      .iterations(forceProperties.link.iterations);

    // updates ignored until this is run
    // restarts the simulation (important if simulation has already slowed down)
    simulation.alpha(1).restart();
  }

  mounted() {
    this.simulation = d3
      .forceSimulation()
      .force(
        "link",
        d3.forceLink().id((d: any) => d.code)
      )
      .force("charge", d3.forceManyBody())
      .force("collide", d3.forceCollide())
      .force("center", d3.forceCenter())
      .force("forceX", d3.forceX())
      .force("forceY", d3.forceY())
      .on("tick", this.tick);

    this.updateForces();

    this.selections.svg = d3.select(this.$el.querySelector("svg"));

    // Define the arrow marker
    this.selections.svg
      .append("svg:defs")
      .selectAll("marker")
      .data(["end"]) // Different link/path types can be defined here
      .enter()
      .append("svg:marker") // This section adds in the arrows
      .attr("id", String)
      .attr("viewBox", "0 -5 10 10")
      .attr("refX", 43) // Prevents arrowhead from being covered by circle
      .attr("refY", 0)
      .attr("markerWidth", 6)
      .attr("markerHeight", 6)
      .attr("orient", "auto")
      .append("svg:path")
      .attr("d", "M0,-5L10,0L0,5");

    this.selections.graph = this.selections.svg.append("g");
  }

  @Watch("grafo", { deep: true })
  handlerGrafo() {
    this.updateData();
  }

  @Watch("forceProperties", { deep: true })
  handlerFP() {
    this.updateForces();
  }
}
</script>

<style>
path.link {
  fill: none;
  stroke: #666;
  stroke-width: 1.5px;
}
path.link.depends {
  stroke: #005900;
  stroke-dasharray: 5, 2;
}
path.link.needs {
  stroke: #7f3f00;
}

circle {
  fill: #b3d1fe;
  stroke: #191900;
  stroke-width: 1.5px;
}
circle.system {
  fill: #cce5ff;
  stroke: #003366;
}
circle.mount {
  fill: #ffe5e5;
  stroke: #660000;
}
circle.init {
  fill: #fda34e;
  stroke: #001900;
}

text {
  font: 14px sans-serif;
  pointer-events: none;
  text-shadow: 0 1px 0 #fff, 1px 0 0 #fff, 0 -1px 0 #fff, -1px 0 0 #fff;
}
</style>
